local L = AceLibrary('AceLocale-2.2'):new('SUF_Configuration')

L:RegisterTranslations('enUS', function() return {

	player_desc = "Options for player frame",
	party_desc = "Options for party frames",
	target_desc = "Options for target frame",
	
	mhp = "Middle Heath Text",
	rhp = "Right Health Text",
	mmp = "Middle Mana Text",
	rmp = "Right Mana Text",
	mhp_desc = "Set middle health text to one of the styles",
	rhp_desc = "Set right health text to one of the styles",
	mmp_desc = "Set middle mana text to one of the styles",
	rmp_desc = "Set right health text to one of the styles",
	hp = "Health Text",
	mp = "Mana Text",
	hp_desc = "Set health text to one of the styles",
	mp_desc = "Set mana text to one of the styles",
	
	currmaxhp = "CurrHP/MaxHP",
	percenthp = "(HP%)",
	completehp = "CurrHP/MaxHP (HP%)",
	deficithp = "Amount of lost HP",	
	mh3completehp = "Same as completehp but uses MobHealth3",
	currmaxmp = "CurrMP/MaxMP",
	percentmp = "(MP%)",
	completemp = "CurrMP/MaxMP (MP%)",
	deficitmp = "Amount of lost MP",
	none = "None",
	
} end)



SUF_Config = SimpleUnitFrames:NewModule('Configuration')

SUF_Config.core.options.args.player = {
	type = 'group',
	name = 'player',
	desc = L['player_desc'],
	args = {	
		mhp = {
			type = 'group',
			name = L['mhp'],
			desc = L['mhp_desc'],
			args = {}
		},
		rhp = {
			type = 'group',
			name = L['rhp'],
			desc = L['rhp_desc'],
			args = {}
		},
		mmp = {
			type = 'group',
			name = L['mmp'],
			desc = L['mmp_desc'],
			args = {}
		},
		rmp = {
			type = 'group',
			name = L['rmp'],
			desc = L['rmp_desc'],
			args = {}
		},
	}
}


SUF_Config.core.options.args.party = {
	type = 'group',
	name = 'party',
	desc = L['party_desc'],
	args = {	
		mhp = {
			type = 'group',
			name = L['mhp'],
			desc = L['mhp_desc'],
			args = {}
		},
		rhp = {
			type = 'group',
			name = L['rhp'],
			desc = L['rhp_desc'],
			args = {}
		},
		mmp = {
			type = 'group',
			name = L['mmp'],
			desc = L['mmp_desc'],
			args = {}
		},
		rmp = {
			type = 'group',
			name = L['rmp'],
			desc = L['rmp_desc'],
			args = {}
		},
	}
}


SUF_Config.core.options.args.target = {
	type = 'group',
	name = 'party',
	desc = L['target_desc'],
	args = {	
		hp = {
			type = 'group',
			name = L['hp'],
			desc = L['hp_desc'],
			args = {}
		},
		mp = {
			type = 'group',
			name = L['mp'],
			desc = L['mp_desc'],
			args = {}
		},
	}
}


function SUF_Config:PopulateOptions(optionTable, db)
	for option in pairs(optionTable.args) do
		for style in pairs(self.core.styles) do
			optionTable.args[option].args[style] = {
				type = 'execute',				
				name = style,
				desc = L[style],
				func = function() db[option] = style end
			}
		end			
	end
end

function SUF_Config:OnInitialize()
	self:PopulateOptions(self.core.options.args.player, self.core.db.profile.Player )
	self:PopulateOptions(self.core.options.args.party, self.core.db.profile.Party )
	self:PopulateOptions(self.core.options.args.target, self.core.db.profile.Target )
end



