SimpleUnitFrames = AceLibrary("AceAddon-2.0"):new("AceModuleCore-2.0", "AceDB-2.0", "AceConsole-2.0")

SimpleUnitFrames.modulePrototype.core = SimpleUnitFrames

SimpleUnitFrames.defaults = {}
SimpleUnitFrames.options = {
	type = 'group',
	args = {}
}

function SimpleUnitFrames:OnInitialize()
	self:RegisterChatCommand( { '/suf' }, self.options )
	self:RegisterDB("SimpleUnitFramesDB")
	self:RegisterDefaults('profile', self.defaults)
end

function SimpleUnitFrames.modulePrototype:GetValueText(unitid, style)
	return self.core.styles[style](unitid)
end


SimpleUnitFrames.styles = {

	["currmaxhp"] = function(unitid) 
		return UnitHealth(unitid) .. '/' .. UnitHealthMax(unitid) 
	end,
	
	["percenthp"] = function(unitid) 
		return string.format( "%d%%", UnitHealth(unitid) * 100 / UnitHealthMax(unitid) ) 
	end,
	
	["completehp"] = function(unitid) 
		local curr, max = UnitHealth(unitid), UnitHealthMax(unitid)
		return string.format( "%d/%d (%d%%)", curr, max, curr*100/max)
	end,
	
	["deficithp"] = function(unitid)
		return UnitHealth(unitid) - UnitHealthMax(unitid)
	end,
	
	["mh3completehp"] = function(unitid)
		local curr, max
		if MobHealth3 then
			curr, max = MobHealth3:GetUnitHealth(unitid)
		else
			curr, max = UnitHealth(unitid), UnitHealthMax(unitid)
		end
		return string.format( "%d/%d (%d%%)", curr, max, curr*100/max)
	end,

	["currmaxmp"] = function(unitid) 
		return UnitMana(unitid) .. '/' .. UnitManaMax(unitid) 
	end,
	
	["percentmp"] = function(unitid) 
		return string.format( "%d%%", UnitMana(unitid) * 100 / UnitManaMax(unitid) ) 
	end,
	
	["completemp"] = function(unitid) 
		local curr, max = UnitMana(unitid), UnitManaMax(unitid)
		return string.format( "%d/%d (%d%%)", curr, max, curr*100/max)
	end,

	["deficitmp"] = function(unitid)
		return UnitMana(unitid) - UnitManaMax(unitid)
	end,
	
	["none"] = function() return "" end,
	
}

