local _G = getfenv(0)

local moduleName = "Party"

local Party = SimpleUnitFrames:NewModule(moduleName, "AceEvent-2.0")

Party.core.defaults[moduleName] = {
	mhp = "percenthp",
	rhp = "currmaxhp",
	mmp = "percentmp",
	rmp = "currmaxmp",
}

function Party:OnInitialize()
	self.db = self.core.db.profile[moduleName]
end


function Party:OnShow()
	if self.db then
		self:RegisterEvent("PARTY_MEMBERS_CHANGED", "UpdateAll");
		self:RegisterEvent("UNIT_HEALTH", "OnHealthChange" )
		self:RegisterEvent("UNIT_MAXHEALTH", "OnHealthChange" )
		self:RegisterEvent("UNIT_MANA", "OnManaChange" )
		self:RegisterEvent("UNIT_MAXMANA", "OnManaChange")
		self:RegisterEvent("UNIT_ENERGY", "OnManaChange")
		self:RegisterEvent("UNIT_MAXENERGY", "OnManaChange")
		self:RegisterEvent("UNIT_RAGE", "OnManaChange")
		self:RegisterEvent("UNIT_MAXRAGE", "OnManaChange")
		self:RegisterEvent("UNIT_DISPLAYPOWER", "OnManaChange")		
		self:UpdateAll()
	end
end

function Party:OnHide()
	self:UnregisterAllEvents()
end

function Party:UpdateAll()
	for i=1, GetNumPartyMembers(), 1 do
		local unitid = 'party' .. i
		if UnitExists(unitid) then
			self:UpdateHealth(unitid)
			self:UpdateMana(unitid)
		end
	end
end

function Party:OnHealthChange(arg1)
	if string.find(arg1, '^party%d$') then
		self:UpdateHealth(arg1)
	end
end

function Party:OnManaChange(arg1)
	if string.find(arg1, '^party%d$') then
		self:UpdateMana(arg1)
	end
end
		

function Party:UpdateHealth(unitid)
	local i = string.sub(unitid, 6, 6)
	_G['SUF_PartyFrame'.. i .. 'HealthMiddle' ]:SetText( self:GetValueText(unitid, self.db.mhp) )
	_G['SUF_PartyFrame'.. i .. 'HealthRight' ]:SetText( self:GetValueText(unitid, self.db.rhp) )
end

function Party:UpdateMana(unitid)
	local i = string.sub(unitid, 6, 6)
	_G['SUF_PartyFrame'.. i .. 'ManaMiddle' ]:SetText( self:GetValueText(unitid, self.db.mmp) )
	_G['SUF_PartyFrame'.. i .. 'ManaRight' ]:SetText( self:GetValueText(unitid, self.db.rmp) )
end

-- Global name for PartyFrame to reach.
SUF_Party = Party