local moduleName = "Player"

local Player = SimpleUnitFrames:NewModule(moduleName, "AceEvent-2.0")

Player.core.defaults[moduleName] = {
	mhp = "currmaxhp",
	rhp = "percenthp",
	mmp = "currmaxmp",
	rmp = "percentmp",
}

function Player:OnInitialize()
	self.db = self.core.db.profile[moduleName]	
end

function Player:OnEnable()

	self:RegisterEvent("UNIT_HEALTH")
	self:RegisterEvent("UNIT_MANA", "OnManaChange")
	self:RegisterEvent("UNIT_RAGE", "OnManaChange")
	self:RegisterEvent("UNIT_FOCUS", "OnManaChange")
	self:RegisterEvent("UNIT_ENERGY", "OnManaChange")
	self:RegisterEvent("UNIT_DISPLAYPOWER", "OnManaChange")
	
	self:UpdateHealth()
	self:UpdateMana()
	
end

function Player:UNIT_HEALTH(arg1)
	if arg1 == 'player' then
		self:UpdateHealth()
	end
end

function Player:OnManaChange(arg1)
	if arg1 == 'player' then
		self:UpdateMana()
	end
end


function Player:UpdateHealth()
	SUF_HealthMiddleText:SetText( self:GetValueText('player', self.db.mhp ) )
	SUF_HealthRightText:SetText( self:GetValueText('player', self.db.rhp ) )	
end

function Player:UpdateMana()
	SUF_ManaMiddleText:SetText( self:GetValueText('player', self.db.mmp ) )
	SUF_ManaRightText:SetText( self:GetValueText('player', self.db.rmp ) )	
end
