local moduleName = "Target"

local Target = SimpleUnitFrames:NewModule(moduleName, "AceEvent-2.0")

Target.core.defaults[moduleName] = {
	hp = "mh3completehp",
	mp = "currmaxmp",
}

function Target:OnInitialize()
	self.db = self.core.db.profile[moduleName]
	TargetDeadText:SetText()
end

function Target:OnEnable()

	self:RegisterEvent("UNIT_HEALTH", "OnHealthChange" )
	self:RegisterEvent("UNIT_MAXHEALTH", "OnHealthChange" )
	self:RegisterEvent("UNIT_MANA", "OnManaChange" )
	self:RegisterEvent("UNIT_MAXMANA", "OnManaChange")
	self:RegisterEvent("UNIT_ENERGY", "OnManaChange")
	self:RegisterEvent("UNIT_MAXENERGY", "OnManaChange")
	self:RegisterEvent("UNIT_RAGE", "OnManaChange")
	self:RegisterEvent("UNIT_MAXRAGE", "OnManaChange")
	self:RegisterEvent("UNIT_DISPLAYPOWER", "OnManaChange")
	self:RegisterEvent("PLAYER_TARGET_CHANGED")
	
end

function Target:PLAYER_TARGET_CHANGED()
	if UnitExists('target') then
		self:UpdateHealth()
		self:UpdateMana()
	end
end

function Target:OnHealthChange(arg1)
	if arg1 == 'target' then
		self:UpdateHealth()
	end
end

function Target:OnManaChange(arg1)
	if arg1 == 'target' then
		self:UpdateMana()
	end
end

function Target:UpdateHealth()
	SUF_TargetHealthText:SetText( self:GetValueText('target', self.db.hp) )
end

function Target:UpdateMana()
	SUF_TargetManaText:SetText( self:GetValueText('target', self.db.mp) )
end
